/* Origin: https://blog.csdn.net/m0_74259636/article/details/128592257
 * Brief: Basic defect detection example, based on image processing.
 */

#include <iostream>
#include <opencv2/opencv.hpp>
#include <opencv2/highgui.hpp>
#include <opencv2/imgproc.hpp>

#include <iostream>  
#include <assert.h>
#include <vector>
#include <stdlib.h>
#include <stdio.h>
#include <cstring>
#include <string>
using namespace std;
using namespace cv;
   int  main() {
	Mat img = imread("/usr/share/opencv4/defect_detection/defect.png");
	Mat img2;
	resize(img, img2, { 600,400 });
	imshow("0. Resize", img2);
	Mat gray_mat;
	cvtColor(img2,  gray_mat, cv::COLOR_BGR2GRAY);
	//imshow("01. Grey-scale Map", gray_mat);
	Mat  bin_mat;
	threshold(gray_mat, bin_mat, 128, 255, THRESH_BINARY);
	//imshow("02.Binary Image", bin_mat);
	Mat  inv_mat;
	inv_mat = 255 - bin_mat;
	//imshow("03.Color Flip", inv_mat);
	//Define a 3*3 matrix element.
	Mat erode_mat;
	cv::Mat element = cv::getStructuringElement(cv::MORPH_RECT, cv::Size(3, 3)); 
	erode(inv_mat, erode_mat, element);
	//imshow("04.Erode", erode_mat);

	//Find the outline from erode_mat，and save the result to contours
	vector<vector<Point>> contours;
	vector<Vec4i> hierarchy;
	findContours(erode_mat, contours, hierarchy, RETR_TREE, CHAIN_APPROX_SIMPLE, Point());
	//Iterate over all contours and highline the defect contours.
	for (int i = 0; i < contours.size(); i++)
	{
        //Calculated the contour area.
	    int aero=contourArea(contours[i]);
	    if (aero > 1000) {
	        drawContours(img2, contours, i, Scalar(0,0,255), -1, 8, hierarchy);
	        cout << i << "  aero:" << aero<<endl;
	    }
    }
	imshow("05.Contours Image", img2);
	waitKey(0);
	return 0; 
}